=== debian/changelog ===
mgba (0.8.4+dfsg-2) unstable; urgency=medium

  * Add upstream patches to remove unused OpenGL code from the libretro core
    and fix its undefined references. (Closes: #986986)
    - debian/patches/CMake-Move-gl.c-and-gles2.c-to-FEATURE_SRC.patch
    - debian/patches/CMake-Move-BUILD_GL-flags-to-FEATURE_DEFINES.patch
  * Add upstream patch to fix PC alignment check when loading a save state.
    - debian/patches/GBA-Serialize-Fix-alignment-check-when-loading-state.patch
  * Add upstream patch to fix crash when unloading a Game Boy ROM in a
    libretro frontend that doesn't implement the camera interface.
    - debian/patches/Libretro-Only-set-camera-peripheral-when-it-is-avail.patch
  * Add upstream patches to fix crashes identified by fuzz testing.
    - debian/patches/Core-Fix-destroying-an-mVL-with-an-invalid-channel-c.patch
    - debian/patches/GB-MBC-Remove-unused-SRAM-size.patch
    - debian/patches/GB-MBC-Force-minimum-SRAM-size-on-rare-MBCs-that-alw.patch
    - debian/patches/GB-Video-Don-t-rendering-negative-batches.patch
    - debian/patches/GB-Video-Fix-deserializing-negative-LX-state.patch
    - debian/patches/GB-Video-Discard-SGB-packets-in-non-SGB-mVLs.patch

 -- Ryan Tandy <ryan@nardis.ca>  Tue, 20 Apr 2021 18:31:14 -0700

mgba (0.8.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Add Build-Depends: zipcmp, zipmerge, ziptool as a workaround for bug
    #973280. Fixes FTBFS with libzip 1.7. (Closes: #973069)

 -- Ryan Tandy <ryan@nardis.ca>  Sun, 01 Nov 2020 18:31:10 -0800
